<template>
  <div class="w-full py-u20" :class="{'pl-u15': align === 'left', 'pr-u15': align === 'right'}">
    <div :class="[`loader--${type}`, {'ml-0': align === 'left', 'mr-0': align === 'right'}]" class="m-auto" />
  </div>
</template>

<script>
export default {
  props: {
    type: {
      type: String,
      default: '3-dot-elastic',
      required: false
    },
    align: {
      type: String,
      default: 'center',
      required: false
    }
  }
}
</script>

<style lang="scss">
/* purgecss start ignore */
// ==============================================
// Variables
// ==============================================

$dot-width: 10px !default;
$dot-height: 10px !default;
$dot-radius: $dot-width/2 !default;

$dot-color: #c4c4c4 !default;
$dot-bg-color: $dot-color !default;
$dot-before-color: $dot-color !default;
$dot-after-color: $dot-color !default;

$dot-spacing: $dot-width + $dot-width/2 !default;

// ==============================================
// Mixins
// ==============================================

@mixin dot(
  $width: $dot-width,
  $height: $dot-height,
  $radius: $dot-radius,
  $bg-color: $dot-bg-color,
  $color: $dot-color
) {
  width: $width;
  height: $height;
  border-radius: $radius;
  background-color: $bg-color;
  color: $color;
}

/**
 * ==============================================
 * 3 Dot Elastic
 * ==============================================
 */

$left-pos: -9999px;
$x1: -$left-pos - $dot-spacing;
$x2: -$left-pos;
$x3: -$left-pos + $dot-spacing;

.loader--3-dot-elastic {
  position: relative;
  left: $left-pos;

  @include dot;

  box-shadow: $x2 0 0 -5px $dot-color;
  animation: dot-pulse 1.5s infinite linear;
  animation-delay: .25s;

  &::before,
  &::after {
    content: '';
    display: inline-block;
    position: absolute;
    top: 0;

    @include dot;
  }

  &::before {
    box-shadow: $x1 0 0 -5px $dot-before-color;
    animation: dot-pulse-before 1.5s infinite linear;
    animation-delay: 0s;
  }

  &::after {
    box-shadow: $x3 0 0 -5px $dot-after-color;
    animation: dot-pulse-after 1.5s infinite linear;
    animation-delay: .5s;
  }
}

@keyframes dot-pulse-before {
  0% {
    box-shadow: $x1 0 0 -5px $dot-before-color;
  }

  30% {
    box-shadow: $x1 0 0 2px $dot-before-color;
  }

  60%,
  100% {
    box-shadow: $x1 0 0 -5px $dot-before-color;
  }
}

@keyframes dot-pulse {
  0% {
    box-shadow: $x2 0 0 -5px $dot-color;
  }

  30% {
    box-shadow: $x2 0 0 2px $dot-color;
  }

  60%,
  100% {
    box-shadow: $x2 0 0 -5px $dot-color;
  }
}

@keyframes dot-pulse-after {
  0% {
    box-shadow: $x3 0 0 -5px $dot-after-color;
  }

  30% {
    box-shadow: $x3 0 0 2px $dot-after-color;
  }

  60%,
  100% {
    box-shadow: $x3 0 0 -5px $dot-after-color;
  }
}
/* purgecss end ignore */
</style>
